struct IterativeDeependingDFS
    d_max_limit::Int
    stack::Vector{TileIndex}
end

function solve(iddfs::IterativeDeependingDFS, game::Game, s::State, reach::ReachableTiles)
    t_start = time()
    d_max = 0
    solved = false
    pushes = Array{Push}(undef, iddfs.d_max_limit)
    data = DepthFirstSearchData(false, 0, 0, 0.0, pushes, 0)
    clear!(reach, game.board)

    while !data.solved && d_max < iddfs.d_max_limit
        d_max += 1
        dfs = DepthFirstSearch(d_max, iddfs.stack)
        solve_(dfs, data, game, s, reach, 0)
    end

    data.solve_time = time() - t_start
    return data
end