struct IterativeDeepeningZobristDFS
    d_max_limit::Int
    stack::Vector{TileIndex}
end

function solve(solver::IterativeDeepeningZobristDFS, game::Game, s::State, reach::ReachableTiles)
    t_start = time()
    d_max = 0
    solved = false
    pushes = Array{Push}(undef, solver.d_max_limit)
    data = ZobristDFSData(false, 0, 0, 0, 0.0, pushes, 0)
    clear!(reach, game.board)

    while !data.solved && d_max < solver.d_max_limit
        d_max += 1
        dfs = ZobristDFS(d_max, solver.stack, Dict{Tuple{TileIndex, UInt64},Int}())
        solve_(dfs, data, game, s, reach, 0)
    end

    data.solve_time = time() - t_start
    return data
end